<template>
  <div class="content">
    <PageTitle>Buildings</PageTitle>
    <div class="col-12 drop-shadow border-radius p-4">
      <SearchField class="w-100 mb-4" v-model="searchQuery"></SearchField>
      <GridComponent
        :data="data"
        :columns="columns"
        :filterKey="searchQuery"
      ></GridComponent>
    </div>
  </div>
</template>

<script>
import PageTitle from "./atoms/PageTitle.vue";
import GridComponent from "./organisms/GridComponent.vue";
import SearchField from "./atoms/SearchField.vue";
import axios from "axios";
import store from "@/store/auth";

export default {
  components: { PageTitle, GridComponent, SearchField },
  data() {
    return {
      data: [],
      columns: ["naam", "route", "stad"],
      searchQuery: "",
    };
  },
  created() {
    this.getRoutes();
  },
  methods: {
    addMockData() {
      this.data = this.data.concat([
        {
          id: 25168,
          student: "Rick Astley",
          route: "Hoog-gent",
          stad: "Gent",
          status: "40%",
          opmerking: 2,
          opmerkingDetail: "",
        },
        {
          id: 25169,
          student: "Rick Astley",
          route: "Laag-gent",
          stad: "Gent",
          status: "54%",
          opmerking: 0,
          opmerkingDetail: "",
        },
        {
          id: 25170,
          student: "Rick Astley",
          route: "'t Zuid",
          stad: "Antwerpen",
          status: "79%",
          opmerking: 0,
          opmerkingDetail: "",
        },
        {
          id: 25171,
          student: "Rick Astley",
          route: "Midden-gent",
          stad: "Gent",
          status: "19%",
          opmerking: 1,
          opmerkingDetail: "",
        },
        {
          id: 25172,
          student: "Rick Astley",
          route: "'t Zuid",
          stad: "Antwerpen",
          status: "10%",
          opmerking: 0,
          opmerkingDetail: "",
        },
      ]);
    },
    async getRoutes() {
      store.commit("general/setLoading", true);
      try {
        await axios.get("/api/building").then((response) => {
          if (response.status === 200) {
            this.setAndRefactor(response.data);
          }
        });
      } catch (error) {
        console.log(error);
      }
      //this.addMockData();
      store.commit("general/setLoading", false);
    },
    setAndRefactor(buildings) {
      this.data = [];
      buildings.forEach((building) => {
        this.data.push({
          id: building.id,
          naam: building.name,
          route: building.round.name,
          stad: building.city,
          student: building.student?.name,
          status: 0,
          opmerking: 0,
        });
      });
    },
  },
};
</script>

<style lang="scss"></style>
